var removetabs_pref_branch = Components.classes["@mozilla.org/preferences-service;1"]
                                       .getService(Components.interfaces.nsIPrefBranch);

function removetabs_removeleft(usecontext) {
	var tabs = gBrowser.tabContainer;
	var ctab = (usecontext ? gBrowser.mContextTab : gBrowser.selectedTab);
	var i;
	for(i=tabs.childNodes.length-1; tabs.childNodes[i] != ctab; i--){}
	for(i--; i>=0; i--){
		gBrowser.removeTab(tabs.childNodes[i]);
	}
	removetabs_updateEnabled();
}

function removetabs_removeright(usecontext) {
	var tabs = gBrowser.tabContainer;
	var ctab = (usecontext ? gBrowser.mContextTab : gBrowser.selectedTab);
	for(var i=tabs.childNodes.length-1; tabs.childNodes[i] != ctab; i--){
		gBrowser.removeTab(tabs.childNodes[i]);
	}
	removetabs_updateEnabled();
}

function removetabs_removeother(usecontext) {
	var ctab = (usecontext ? gBrowser.mContextTab : gBrowser.selectedTab);
	gBrowser.removeAllTabsBut(ctab);
	removetabs_updateEnabled();
}

function removetabs_removeall(usecontext) {
	var ctab = gBrowser.addTab("about:blank");
	gBrowser.removeAllTabsBut(ctab);
	if(gBrowser.tabContainer.childNodes.length > 1) {
		gBrowser.removeTab(ctab);
	}
	removetabs_updateEnabled();
}

function removetabs_setDisabled(id, value) {
	var item = gBrowser.ownerDocument.getElementById(id);
	if(item == null){ return; }
	item.setAttribute("disabled", value);
}

function removetabs_updateEnabled() {
	var tabs = gBrowser.tabContainer;
	removetabs_setDisabled("tab-removeleftmenu",
		(tabs.childNodes[0] == gBrowser.mContextTab));
	removetabs_setDisabled("tab-removerightmenu",
		(tabs.childNodes[tabs.childNodes.length-1] == gBrowser.mContextTab));
	removetabs_setDisabled("tab-removeallmenu",
		(tabs.childNodes.length <= 1 && 
		 gBrowser.currentURI.spec == "about:blank"));
	removetabs_setDisabled("removeleftbutton",
		(tabs.childNodes[0] == gBrowser.selectedTab));
	removetabs_setDisabled("removerightbutton",
		(tabs.childNodes[tabs.childNodes.length-1] == gBrowser.selectedTab));
	removetabs_setDisabled("removeotherbutton",
		(tabs.childNodes.length <= 1));
	removetabs_setDisabled("removeallbutton",
		(tabs.childNodes.length <= 1 && 
		 gBrowser.currentURI.spec == "about:blank"));
}

function removetabs_addMenuItem(browser, menuid) {
	if(!browser){ return; }
	var removetabsMenu = browser.ownerDocument.getElementById(menuid).cloneNode(false);
	if(!removetabsMenu){ return; }
	removetabsMenu.id = "tab-" + menuid;
	var menuParent = browser.mStrip.firstChild.nextSibling;
	var pos = 4;
	if(pos >= menuParent.childNodes.length){
	  menuParent.appendChild(removetabsMenu);
	}else{
	  menuParent.insertBefore(removetabsMenu, menuParent.childNodes[pos]);
	}
}

function removetabs_addMenuItems(browser) {
	if(removetabs_getPrefValue("extensions.removetabs.add_removeleft_menu")) {
		removetabs_addMenuItem(browser, "removeleftmenu");
	}
	if(removetabs_getPrefValue("extensions.removetabs.add_removeright_menu")) {
		removetabs_addMenuItem(browser, "removerightmenu");
	}
	if(removetabs_getPrefValue("extensions.removetabs.add_removeall_menu")) {
		removetabs_addMenuItem(browser, "removeallmenu");
	}
}

function removetabs_init() {
	if(!gBrowser){ return; }
	removetabs_addMenuItems(gBrowser);

	var menuParent = gBrowser.mStrip.firstChild.nextSibling;
	menuParent.addEventListener("popupshowing", removetabs_updateEnabled, false);
	var contentArea = gBrowser.ownerDocument.getElementById("appcontent");
	contentArea.addEventListener("load", removetabs_updateEnabled, true);
	contentArea.addEventListener("select", removetabs_updateEnabled, false);
	contentArea.addEventListener("unload", removetabs_updateEnabled, true);
	removetabs_updateEnabled();
}

function removetabs_getPrefValue(aPrefString){
	var defaultValue = removetabs_getDefaultValue(aPrefString);
	var result = defaultValue;

	try{
		switch(typeof(defaultValue)){
			case "boolean":
				result = removetabs_pref_branch.getBoolPref(aPrefString);
				break;
			case "number":
				result = removetabs_pref_branch.getIntPref(aPrefString);
				break;
			case "string":
				result = removetabs_pref_branch.getCharPref(aPrefString);
				break;
		}
	}catch(ex){
		try{
			var oldPrefString = aPrefString.replace("extensions.", "skz.");
			result = removetabs_pref_branch.getBoolPref(oldPrefString);
			removetabs_pref_branch.setBoolPref(aPrefString, result);
			removetabs_pref_branch.deleteBranch(oldPrefString);
		}catch(e){
			result = defaultValue;
		}
	}		
	return result;
}

function removetabs_getDefaultValue(aPrefString){
	switch(aPrefString){
		case "extensions.removetabs.add_removeleft_menu":
			return true;
		case "extensions.removetabs.add_removeright_menu":
			return true;
		case "extensions.removetabs.add_removeall_menu":
			return false;
	}
	return true;
}

